/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1"
#define BUFFSZ      256



void ww_pwd(unsigned char *data);



int main(void) {
    HKEY            key;
    int             i,
                    len;
    unsigned char   buff[BUFFSZ + 1],
                    *keyz[] = {
                        ".a5z",
                        ".a5x",
                        NULL
                    },
                    *p,
                    *d;

    fputs("\n"
        "Willing Webcam password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    for(i = 0; keyz[i]; i++) {
        len = BUFFSZ;
        if(RegOpenKeyEx(HKEY_CLASSES_ROOT, keyz[i], 0, 0, &key) || RegQueryValueEx(
          key,
          "String",
          NULL, \
          NULL, \
          buff, \
          (void *)&len)) {
            printf("\n- registry key %s not found\n", keyz[i]);
            continue;
        }
        RegCloseKey(key);

        ww_pwd(buff);
        printf("\n  Full decoded string   %s\n", buff);

        p = strchr(d = buff, ':');
        if(!p) continue;
        printf("  Stealth Mode          %s\n", !atoi(d) ? "off" : "on");

        p = strchr(d = p + 1, ':');
        if(!p) continue;

        p = strchr(d = p + 1, ':');
        if(!p) continue;
        printf("  Password Enabled      %s\n", !atoi(d) ? "off" : "on");

        p = strchr(d = p + 1, ':');
        if(!p) continue;
        *p = 0;
        printf("  Password              %s\n", d);
    }

    fputs("\n  Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void ww_pwd(unsigned char *data) {
    while(*data) *data++ ^= 0xb;
}


